#include "direxec.h"

direxec::direxec()
{
 hstmt = NULL ;
 retcode = SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HANDLE, &henv);  
 if ( !Bad() ) {   /* Set the ODBC version environment attribute */
   retcode = SQLSetEnvAttr(henv, SQL_ATTR_ODBC_VERSION, (void*)SQL_OV_ODBC3, 0); 
   if (retcode == SQL_SUCCESS || retcode == SQL_SUCCESS_WITH_INFO) 
      /* Allocate connection handle */
		retcode = SQLAllocHandle(SQL_HANDLE_DBC, henv, &hdbc); 
   else
		error_out(hdbc, SQL_HANDLE_DBC); //Error
 }
 else
	error_out(henv, SQL_HANDLE_ENV); //Error
}

// Allocate environment handle, allocate connection handle, 
// connect to data source, and allocate statement handle.
void direxec::sqlconn(unsigned char * ConnString)
{
 BYTE OutConnStr[1024];
 short StrLenOut;
 if (ConnString)
    _mbscpy(ConnStrIn, (const unsigned char *) ConnString);

	/*Allocate environment handle */
 if (retcode == SQL_SUCCESS || retcode == SQL_SUCCESS_WITH_INFO) 
 {        /* Set login timeout to 5 seconds. */
   //SQLSetConnectAttr(hdbc, SQL_LOGIN_TIMEOUT, 5, 0);
         /* Connect to data source */
	retcode=SQLDriverConnect(hdbc,NULL,	ConnStrIn, sizeof(ConnStrIn), 
			OutConnStr, 1024, &StrLenOut, SQL_DRIVER_NOPROMPT);
	if (Bad() /*retcode!=SQL_SUCCESS*/)
		error_out(hdbc, SQL_HANDLE_DBC); //Error
		error_out(henv, SQL_HANDLE_ENV); //Error
 }
}

direxec::~direxec()
{	
 sqldisconn();
 SQLFreeHandle(SQL_HANDLE_DBC, hdbc);
 SQLFreeHandle(SQL_HANDLE_ENV, henv);
}

// Execute SQL command with SQLExecDirect() ODBC API.
void direxec::sqlexec(unsigned char * cmdstr)
{
 if(NULL != hstmt )
	SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
 retcode = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt); 
 if (!MYSQLSUCCESS(retcode))  
 {  error_out(hstmt); error_out(hdbc,SQL_HANDLE_DBC); return; } //Error
 
 retcode = SQLExecDirect(hstmt,cmdstr,SQL_NTS);
 if (!MYSQLSUCCESS(retcode))  {error_out(hstmt); return; } //Error
}

// Free the statement handle, disconnect, free the connection handle and
// free the environment handle.
void direxec::sqldisconn(void)
{
 SQLFreeHandle(SQL_HANDLE_STMT, hstmt);
 SQLDisconnect(hdbc);
}

// Display error message in a message box that has an OK button.
void direxec::error_out(HSTMT stmt, SQLSMALLINT HandleType)
{
	unsigned char szSQLSTATE[10], msg[SQL_MAX_MESSAGE_LENGTH+1];
	SDWORD nErr;	SWORD cbmsg;
	//while((SQLError(0,0,stmt,szSQLSTATE,&nErr,msg,sizeof(msg),&cbmsg))==SQL_SUCCESS)
	for(int i=1; i<16 && SQLGetDiagRec(HandleType ,stmt, i, szSQLSTATE, &nErr, msg, sizeof(msg), &cbmsg)==SQL_SUCCESS;i++)
	{
		wsprintf((char *)szData,"SQLSTATE=%s,\n Native error=%ld,\n msg='%s'",
			szSQLSTATE,nErr,msg);
		MessageBox(NULL,(const char *)szData,"ODBC Error",MB_OK);
	}
}

// Binds data to var
void direxec::sqlBind(UWORD icol, SWORD fcType, PTR rgbVal, SDWORD cbValMax, SDWORD FAR* pcbVal)
{
  retcode=SQLBindCol(hstmt, icol, fcType, rgbVal, cbValMax, pcbVal); 
  if (!MYSQLSUCCESS(retcode))  error_out(hstmt); //Error
}

//fFetchType, irow, pcrow, rgfRowStatus
void direxec::sqlExtFetch(UWORD fFetchType, SDWORD irow)
{
 retcode=SQLExtendedFetch(hstmt, fFetchType, irow, &crow, rgfRowStatus); 
 if (Bad())  error_out(hstmt); //Error
}

const char* direxec::RecCount()  { return (const char *)rec_count; }
BOOL direxec::Bad()
{  return (retcode != SQL_SUCCESS) & (retcode != SQL_SUCCESS_WITH_INFO); }

/************************************************************************/
void direxec::sqlGetColumn(UINT ColNum, Column *Col)
{
//static SQLHSTMT hstmt2;

//if(ColNum++==0 || _mbscmp(szTableName, szTN) )
//{
//
 // _mbscpy(szTableName, szTN);
//  retcode = SQLAllocHandle(SQL_HANDLE_STMT, hdbc, &hstmt2); 
 // retcode = SQLColumns(hstmt2, NULL/*(unsigned char *)""*/, 0, 
//			/*(unsigned char *)""*/ NULL, 0, szTableName, SQL_NTS, NULL, 0);     /* All columns  */
 // if (retcode == SQL_SUCCESS || retcode == SQL_SUCCESS_WITH_INFO) {
 //  /* Bind columns in result set to buffers */
  // SQLBindCol(hstmt2, 4, SQL_C_CHAR, szColumnName, STR_LEN, &cbColumnName);
  // SQLBindCol(hstmt2, 5, SQL_C_SSHORT, &DataType,    0, &cbDataType);
  // SQLBindCol(hstmt2, 7, SQL_C_SLONG,  &ColumnSize,  0, &cbColumnSize);
 //  SQLBindCol(hstmt2, 14,SQL_C_SSHORT, &SQLDataType, 0, &cbSQLDataType);
//  }
//  else	  { error_out(hstmt2); 	  return; }
//}
//retcode = SQLFetchScroll(hstmt, SQL_FETCH_ABSOLUTE, ColNum);
//retcode = SQLFetch(hstmt2);//, SQL_FETCH_FIRST, ColNum);
//if (Bad())  
//	error_out(hstmt2);
//else

/*SQLSMALLINT cbSize; // total number of bytes (excluding the null-termination byte) available to return in *ColumnName
SQLSMALLINT DataTypePtr;
SQLUINTEGER ColumnSizePtr;
SQLSMALLINT DecimalDigitsPtr;
SQLSMALLINT NullablePtr;*/

retcode = SQLDescribeCol(hstmt, ColNum, Col->szColName, 32, &Col->cbSize, 
		&Col->DataTypePtr, &Col->ColumnSizePtr, &Col->DecimalDigitsPtr, &Col->NullablePtr);
}
